% Auxiliary function for unitary_QZ_ds.m;
% given quasiseparable generators, it computes 
% the corresponding matrix. Useful to check that 
% everything is going ok!
%
% Please note that no check is performed on 
% input size. We just assume it's correct!

function A=compute_matrix_A(g,h,b,sigma,p,q)
n=length(p); % this is hopefully the size of A
A=zeros(n);
% we first compute the unitary part; later
% we will add the rank one correction

% fill triangular upper part of A
for i=1:n-1
    for j=i+1:n
        x=h(:,j);
        for k=j-1:-1:i
            x=b(:,:,k)*x;
        end
        A(i,j)=g(i,:)*x-p(i)*q(j);
    end
end
% fill diagonal of A
for j=1:n
    A(j,j)=g(j,:)*h(:,j)-p(j)*q(j);
end
% fill subdiagonal of A
for j=1:n-1
    A(j+1,j)=sigma(j);
end

