function [H,y]=hh3(x)

% for x column vector of length 3,
% computes a unitary H such that H*x has the
% second and third entries equal to zero

% should be edited to deal with case where x=[a;0;0],
% in which case we want the output to be the identity matrix ?


% Givens x Givens
% %
%     
% [H1,y1]=planerot(x(2:3));
% x=[x(1); y1];
% [H2,y]=planerot(x(1:2));
% H1=[1 0 0; zeros(2,1) H1];
% H2=[H2 zeros(2,1); 0 0 1];
% H=H2*H1;

% Houselholder (naive)
% v=x/norm(x)-[1;0;0];
% u=v/norm(v);
% H=eye(3)-2*(u*u');
% y=[norm(x);0;0];

% Householder (less naive)
% nx=norm(x);
% s=-sign(x(1));
% u1=x(1)-s*nx;
% w=x/u1;
% w(1)=1;
% tau=-s*u1/nx;
% H=eye(3)-tau*(w*w');
% y=x-tau*w*(w'*x);

% Householder (as in Golub & Van Loan)

 s=x(2)*x(2)+x(3)*x(3);
 v=[1;x(2);x(3)];
 if (s==0)
     beta=0;
 else
     mu=sqrt(x(1)^2+s);
     if x(1)<=0
         v(1)=x(1)-mu;
     else
         v(1)=-s/(x(1)+mu);
     end
     beta=(2*v(1)^2)/(s+v(1)^2);
     v=v/v(1);
 end
 H=eye(3)-beta*(v*v');
 y=x-beta*v*(v'*x);
